<?php
/**
  * This plugin can be used to insert a hit-counter on your page
  * When installed, it will create a table in your database named 
  * "nucleus_plugin_counter" with only three columns and one row in
  * this tabel. Now I know the option can be used to stor the count,
  * but I don't want to change it. It is just in the same way.
  * Any question or suggestion, please contact:
  *      webmaster@barb.51.net
  *      http://barb.51.net
  *
  * History:
  *  v0.3b: - fix text counter output
  *  v0.3a: - add minimum version support
  *   v0.3: - fixed XHTML 1.0 warning
  *         - use sql_table
  *         - added supportsFeature
  *   v0.2: Add 2 options, so it now can be graphical counter.
  *   v0.1: just finished, and worked on my blog.
  */


class NP_Counter extends NucleusPlugin { 

	/* plugin info */

    // Note: I never run this plugin on 2.0 and have no idea whether it 
    //       wil work on <2.5. A user can simply chnage it to return
    //       '200' and see if it works (likely will). I will gladly 
    //       change the min version to 2.0 and add the sql_table fix
    //       upon such report. 8)
    function getMinNucleusVersion() { return '250'; }
    function getName() { return 'Hit Counter'; } 
    function getAuthor()  { return 'Qi Liangpei | Edmond Hui (admun)'; } 
    function getURL()  { return 'http://barb.51.net'; } 
    function getVersion() { return '0.3b'; } 
    function getDescription() { return 'Display how many vistors browse your blog.'; } 

    function install() {
	sql_query('CREATE TABLE IF NOT EXISTS ' . sql_table('plugin_counter') . ' (
		count_time DATETIME NOT NULL default "2003-08-14 23:00:00", 
		count_num int NOT NULL default "0", 
		count_begin DATETIME NOT NULL default "2003-08-15 23:00:00")'
	); 
	$install_date = date("Y-m-d H:i:s");
	$query = "INSERT INTO " . sql_table('plugin_counter') . " VALUES ('$install_date','1','$install_date')";
	sql_query($query);
	$this->createOption('graphical_counter','Graphical Counter','yesno','yes');
	$this->createOption('graphics_path','Graphics Path/URL to graphics. Ensure this path correct. It must be ended with a /','text','./nucleus/plugins/counter/');
    }

    function supportsFeature($what) {
    	switch($what) {
      		case 'SqlTablePrefix':
        		return 1;
      		default:
        		return 0;
    	}
    }

    function unInstall() {
	mysql_query('DROP TABLE ' . sql_table('plugin_counter')); 
    }

    function doSkinVar($skinType) {
	global $manager, $blog, $CONF;
	$query_number = mysql_query("SELECT * FROM " . sql_table('plugin_counter'));

	if ($the_number = mysql_fetch_array($query_number)) {
		$old_number = $the_number["count_num"];
		$begin_date = $the_number["count_begin"];
		$new_number = $old_number + 1;
		$newdate = date("Y-m-d H:i:s");
		$update_query = "UPDATE " . sql_table('plugin_counter') . " SET count_num = '$new_number', count_time = '$newdate' WHERE count_num = '$old_number'";
		$update_result = mysql_query($update_query);

		if ($this->getOption(graphical_counter) == "yes") {
			$image_path = $this->getOption(graphics_path);
			$image_out = '';
			$num = strlen ($new_number);
			$i = 0;

			while ($i < $num) {
				$digit = substr ($new_number, $i, 1);
				$image_out .= '<img src="' . $image_path . $digit . '.jpg" alt="' . $digit .'" />';
				$i++;
			}

			echo "<br />This site has been accessed " . $image_out . " times since " . $begin_date;
		} else {
			echo "There have been " . $new_number . " vistors since " . $begin_date . ".<br />";
		}	

	}
    }
}
?>
